# first line: 1
@mem.cache
def run_solver(events, u_init, sigma_init, baseline_init, alpha_init, T, dt, seed=0):
    start = time.time()
    max_iter = 800
    solver = HawkesDiscretL2(
        "RaisedCosine",
        torch.tensor(u_init),
        torch.tensor(sigma_init),
        torch.tensor(baseline_init),
        torch.tensor(alpha_init),
        dt,
        solver="RMSprop",
        step_size=1e-3,
        max_iter=max_iter,
        log=False,
        random_state=seed,
        device="cpu",
    )
    results = solver.fit(events, T) 
    return results
